def MCS(vertices, neighbors):

   a = [None for i in range(len(vertices))]
   a_ = [None for i in range(len(vertices))]     

   Set = [None for i in range(len(vertices))]
   Size = [None for i in range(len(vertices))] 

   for i in range(len(vertices)):
      Set[i] = set([])     
      Size[i] = 0
      Set[0].add(i)

   j = 0
   for i in range(len(vertices)):
      v = Set[j].pop()
      a[v] = i
      a_[i] = v
      Size[v] = -1
      for u in neighbors[v]:
         if Size[u] >= 0:
            Set[Size[u]].remove(u)
            Size[u] = Size[u] + 1
            Set[Size[u]].add(u)
      j = j + 1
      while j >= 0 and j < len(vertices) and not Set[j]:
         j = j - 1

   return a, a_


def FIC(vertices, neighbors, a, a_):
   
   f = [None for i in range(len(vertices))]
   index = [None for i in range(len(vertices))]
   fill = list()

   for i in range(len(vertices)-1,-1,-1):
      w = a_[i]
      f[w] = w
      index[w] = i
      for v in neighbors[w]:
         if a[v] > i:
            x = v
            while index[x] > i:
               index[x] = i
               fill.append((x,w) if x<w else (w,x))
               x = f[x]
            if f[x] == x: f[x] = w

   return fill
